<?xml version="1.0" encoding="UTF-8"?>

<databaseChangeLog
  xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog
         http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-2.0.xsd">

  <changeSet id="create-ea-table" author="nat">
    <createTable tableName="employing_authority">
      <column autoIncrement="true" name="id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="ea_pkey"/>
      </column>
      <column name="ea_code" type="VARCHAR(50)"/>
      <column name="name" type="VARCHAR(1000)"/>
      <column name="employer_type" type="VARCHAR(20)"/>
      <column name="created_by" type="VARCHAR(50)"/>
      <column name="modified_by" type="VARCHAR(50)"/>
      <column name="created_date" type="TIMESTAMP WITHOUT TIME ZONE"/>
      <column name="modified_date" type="TIMESTAMP WITHOUT TIME ZONE"/>
    </createTable>
  </changeSet>

  <changeSet id="ea-table-updates" author="nat">
    <comment>insert queries</comment>
    <sql
      splitStatements="true"
      stripComments="true">
      insert into employing_authority (ea_code, name) (select o.ea_code, o.name from organisation o);
    </sql>
  </changeSet>

  <changeSet id="ea-emptype-update" author="nat">
    <comment>insert queries</comment>
    <sql
      splitStatements="true"
      stripComments="true">
      update employing_authority a
      set employer_type = s.employer_type
      from
      (select f.employer_type, e.id
      from finance_user f, organisation o, employing_authority e
      where f.organisation_id = o.id
      and o.ea_code = e.ea_code) s
      where a.id = s.id;
    </sql>
  </changeSet>

  <changeSet id="create-org-users-table" author="nat">
    <createTable tableName="org_users">
      <column autoIncrement="true" name="id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="org_users_pkey"/>
      </column>
      <column name="user_id" type="BIGINT"/>
      <column name="org_id" type="BIGINT"/>
    </createTable>
  </changeSet>

  <changeSet id="org-users-data-updates" author="nat">
    <comment>insert queries</comment>
    <sql
      splitStatements="true"
      stripComments="true">
      insert into org_users (user_id, org_id) (select b.id user_id, c.id org_id from finance_user b, organisation c
      where c.id = b.organisation_id
      order by b.id);
    </sql>
  </changeSet>

  <changeSet id="create-org-eas-table" author="nat">
    <createTable tableName="org_eas">
      <column autoIncrement="true" name="id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="org_eas_pkey"/>
      </column>
      <column name="ea_id" type="BIGINT"/>
      <column name="org_id" type="BIGINT"/>
    </createTable>
  </changeSet>

  <changeSet id="org-eas-data-updates" author="nat">
    <comment>insert queries</comment>
    <sql
      splitStatements="true"
      stripComments="true">
      insert into org_eas (ea_id, org_id) (select b.id ea_id, c.id org_id from employing_authority b, organisation c
      where c.ea_code = b.ea_code
      order by b.id);
    </sql>
  </changeSet>

  <changeSet id="drop-organisation-column-from-finance-user" author="nat">
    <dropColumn
      columnName="organisation_id"
      tableName="finance_user"/>
  </changeSet>

  <changeSet id="drop-employer-type-column-from-finance-user" author="nat">
    <dropColumn
      columnName="employer_type"
      tableName="finance_user"/>
  </changeSet>

  <changeSet id="drop-eacode-column-from-organisation" author="nat">
    <dropColumn
      columnName="ea_code"
      tableName="organisation"/>
  </changeSet>

</databaseChangeLog>